//Problem B of ACM ICPC, Tehran Region, November 2009
//Author: Aideen NasiriShargh (aideen.ir)
//From team: Sibilization
#include <cctype>
#include <iostream>
#include <string>
#include <cstring>
#include <set>
#include <algorithm>
#define FOR(i,x,n) for(__typeof(x) i = (x); i != (n); i++)
#define FR(i,n) FOR(i,0,n)
#define FRI(it,v) FOR(it,v.begin(),v.end())
#define SZ size()
#define CLR(a,v) memset(a,v,sizeof a)
#define MP make_pair
#define isin(a,v) ((a).find(v) != (a).end())
#define show(x) cerr<<#x<<"="<<x<<endl;
using namespace std;

const int MAX_N = 10*1000 + 13;

int head[MAX_N], row[MAX_N], col[MAX_N];

int main() {
  FOR(i,1,1+MAX_N)
    head[i] = 1 + (i*(i-1))/2;

  //FR(i,10) show(head[i]);

  int k = 0;
  for (int i=1; i<=MAX_N; i++) {
    if (i == head[k+1])
      k++;
    row[i] = k;
    col[i] = 1+(i-head[row[i]]);
    
    // if (i <= 30) cerr << i << " : " << row[i] << " " << col[i] << endl;
  }


  int x, y;
  while (cin >> x >> y && x && y) {
    if (x > y)
      swap(x, y);
    
    int diffr = row[y] - row[x];

    int ans = 0;
    if (col[y] <= col[x])
      ans = diffr + (col[x] - col[y]);
    else
      ans = max(diffr, col[y] - col[x]);

    cout << ans << endl;
  }
  return 0;
}
