//Problem C of ACM ICPC, Tehran Region, November 2009
//Author: Aideen NasiriShargh (aideen.ir)
//From team: Sibilization
#include <cctype>
#include <iostream>
#include <string>
#include <cstring>
#include <set>
#include <algorithm>
#define FOR(i,x,n) for(__typeof(x) i = (x); i != (n); i++)
#define FR(i,n) FOR(i,0,n)
#define FRI(it,v) FOR(it,v.begin(),v.end())
#define SZ size()
#define CLR(a,v) memset(a,v,sizeof a)
#define MP make_pair
#define isin(a,v) ((a).find(v) != (a).end())
using namespace std;

const int dd[4][2] = {{0,-1}, {0, 1}, {1, 0}, {-1, 0}};
typedef pair <int, int> Pr;

set<Pr> s;
int n;

int main() {
  int x, y;
  while (cin >> n && n) {
    s.clear();
    FR(i,n) {
      cin >> x >> y;
      s.insert(MP(x,y));
    }

    int ans = 0;
    FRI(it,s) {
      int x = it->first, y = it->second;
      FR(d, 4) {
	int xx = x + dd[d][0], yy = y + dd[d][1];
	if (!isin(s,MP(xx,yy)))
	  ans ++;
      }
    }

    cout << ans << endl;
  }
}
