//Problem D of ACM ICPC, Tehran Region, November 2009
//Author: Saeedreza Seddigihin (http://ce.sharif.edu/~seddighin)
//From team: Sibilization
#include <iostream>
#include <cstdio>

using namespace std; 

const int INF=1<<25,MAX_N=500+20;

int n,next[MAX_N],prev[MAX_N],sum[MAX_N],m,d,num[MAX_N],dyna[MAX_N];
bool is_in[MAX_N];

bool contain(int s,int t){
  return(sum[t] > sum[s-1]);
}

int main() {
  while (cin>>n>>m>>d){
    if (n ==0 && m == 0 && d == 0) break;

    for (int i=0;i<MAX_N;i++){
      num[i]=prev[i]=sum[i]=is_in[i]=next[i]=0;
    }

    for (int i=1;i<=m;i++){
      int x;
      cin>>x;
      is_in[x]=true;
    }

    for (int i=1;i<=d;i++)
      cin>>num[i];
    sort(num+1,num+d+1);

    for (int i=1;i<=n;i++) sum[i]=sum[i-1]+is_in[i];

    prev[0]=INF;
    next[n+1]=INF;

    for (int i=1;i<=n;i++){
      if (is_in[i]) prev[i]=0;
      else prev[i]=prev[i-1]+1;
    }
    for (int i=n;i>=1;i--){
      if (is_in[i]) next[i]=0;
      else next[i]=next[i+1]+1;
    }


    for (int i=1;i<MAX_N;i++) dyna[i]=INF;
    dyna[0]=0;

    for (int i=1;i<=d;i++){
      for (int j=i;j<=d;j++){
	int best=num[j]-num[i]+1;
	if (!contain(num[i],num[j]))
	  best+=min(prev[num[i]],next[num[j]]);
	dyna[j]=min(dyna[j],dyna[i-1]+best);
      }
    }
    cout<<dyna[d]<<endl;
  }
  return 0;
}
