//Problem H of ACM ICPC, Tehran Region, November 2009
//Author: Aideen NasiriShargh (aideen.ir)
//From team: Sibilization
#include <cctype>
#include <map>
#include <set>
#include <iostream>
#include <string>
#include <cstring>
#include <set>
#include <algorithm>
#define FOR(i,x,n) for(__typeof(x) i = (x); i != (n); i++)
#define FR(i,n) FOR(i,0,n)
#define FRI(it,v) FOR(it,v.begin(),v.end())
#define SZ size()
#define CLR(a,v) memset(a,v,sizeof a)
#define MP make_pair
#define isin(a,v) ((a).find(v) != (a).end())
#define show(x) cerr<<#x<<"="<<x<<endl;
#define POS first
#define SIGN second
#define ALL(v) v.begin(),v.end()
#define LEFT first
#define RIGHT second
#define PB push_back
using namespace std;

const int MAX_N = 1000 + 13;
const int INF = 1000*1000;

typedef pair<int, int> Pr;

struct person {
  int p;
  int v;
  Pr l, r;
  int wl, wr;
} a[MAX_N];

int n, npos, nneg;
int d[MAX_N][MAX_N];
set<int> vl[MAX_N], vr[MAX_N];

int solve() {

  FR(i,n) {
    if (a[i].l.POS == -INF) a[i].wl = -1;
    else  a[i].wl = a[i].p-a[i].l.POS;
    if (a[i].r.POS == INF) a[i].wr = -1;
    else  a[i].wr = a[i].r.POS-a[i].p;
  }

  // FR(i,n) {
  //   cerr << a[i].wl << " " << a[i].wr << endl;
  // }
    

  FR(i,MAX_N)
    { vl[i].clear(); vr[i].clear(); }
  FR(i,n) {
    if (a[i].wl != -1)   vl[a[i].wl].insert(i);
    if (a[i].wr != -1)   vr[a[i].wr].insert(i);
  }

  // FR(i,10)
  //   cerr << i << " $ " << getl[i] << " " << getr[i] << endl;

  for (int i=0; i<=620; i++)
    for (int j=0; j<=620; j++)
      d[i][j] = -INF;
  d[0][0] = 0;

  int ans = 0;
  for (int nl = 0; nl <= 610; nl++)
    for (int nr = 0; nr <= 610; nr++) {
      int curd = d[nl][nr];
      ans = max(ans, curd);
       // if (nr <= 5 && nl <= 5)
       // 	cerr << nl << " : " << nr << " : " << d[nl][nr] << endl;

      //gl[nl+1];
      int gl = 0;
      FRI(it,vl[nl+1])  {
	int i = *it;
      //FR(i,n) if (a[i].wl == nl+1)
	if (a[i].wr == -1 || a[i].wr > nr)
	  gl += a[i].v * a[i].l.SIGN;
      }

      //gr[nr+1]
      int gr = 0;
      FRI(it,vr[nr+1]) {
	int i = *it;
      //FR(i,n) if (a[i].wr == nr+1) //FRI(it,vr[nr+1]) 
	if (a[i].wl == -1 || a[i].wl > nl)
	  gr += a[i].v * a[i].r.SIGN;
      }
      // if (nr <= 5 && nl <= 5) {
      // 	show(gl);
      // 	show(gr);
      // }

      int &dl = d[nl+1][nr];
      dl = max(dl, curd + gl);

      int &dr = d[nl][nr+1];
      dr = max(dr, curd + gr);
    }
  return ans;
}

int main() {
  while (cin >> n >> npos >> nneg && n) {
    FR(i,n) {
      cin >> a[i].p >> a[i].v;
      a[i].l = MP(-INF,0);
      a[i].r = MP(INF,0);
    }

    int x; 
    Pr cur;

    FR(t,2) {
      int num = (t==0)?npos:nneg;
      FR(j,num) {
	cin >> x; 
	int thissign = (t == 0) ? +1 : -1;
	cur = MP(x, thissign); // positive
	FR(i,n) 
	  if (cur.POS > a[i].p) {
	    if (cur.POS < a[i].r.POS) a[i].r = cur;
	  }
	  else if (cur.POS < a[i].p) {
	    if (cur.POS > a[i].l.POS) a[i].l = cur;
	  }
      
      }
    } // t

    int ans = solve();
    cout << ans << endl;
  }
  return 0;
}
