//Problem A of ACM ICPC, Tehran Region, November 2009
//Author: Aideen NasiriShargh (aideen.ir)
//From team: Sibilization
#include <cctype>
#include <iostream>
#include <string>
#include <cstring>
#define FOR(i,x,n) for(__typeof(x) i = (x); i != (n); i++)
#define FR(i,n) FOR(i,0,n)
#define FRI(it,v) FOR(it,v.begin(),v.end())
#define SZ size()
#define CLR(a,v) memset(a,v,sizeof a)
using namespace std;

const int MAX_N = 200 + 13;
string s;
int mask[MAX_N];
int n;

int solve(string s) {
  n = s.SZ;
  CLR(mask, 0);
  FR(i,n) {
    if (isupper(s[i])) mask[i] = 1;
    if (islower(s[i])) mask[i] = 2;
    if (isdigit(s[i])) mask[i] = 4;
  }

  int best = n+1;
  for (int len=6; len <= n; len++)
    for (int i=0; i+len <= n; i++) {
      int curmask = 0;
      for (int j=i; j<i+len; j++)
	curmask |= mask[j];
      if (curmask == 7)
	return len;
    }
  if (best == n+1)
    return 0;
  return 0;
}

int main() {
  int testn; cin >> testn;
  FR(testi,testn) {
    cin >> s;
    int ans = solve(s);
    cout << ans << endl;
  }
}
