//Problem E of ACM ICPC, Tehran Region, November 2009
//Author: Saeedreza Seddigihin (http://ce.sharif.edu/~seddighin)
//From team: Sibilization
#include <iostream>
#include <cstdio>
#include <map>
#include <vector>
#define int long long

using namespace std; 

typedef pair<int,int> Pair;

inline bool is_left(Pair a,Pair b,Pair c){
  c.first-=a.first;
  c.second-=a.second;
  b.first-=a.first;
  b.second-=a.second;
  return(b.first*c.second > b.second * c.first);
}

main(){
  int n;
  while (cin>>n){
    if (n == 0) break;
    map<Pair,int> Map;
    for (int i=1;i<=n;i++){
      int x,y,z;
      cin>>z>>x>>y;
      Map[Pair(x,y)]+=z;
    }
    vector<Pair> all;
    vector<int> num;
    for (map<Pair,int> :: iterator i=Map.begin();i!=Map.end();i++){
      all.push_back(i->first);
      num.push_back(i->second);
    }
    int ans=0;
    for (int i=0;i<all.size();i++)
      for (int j=i+1;j<all.size();j++){
	int sum1=0,sum2=0;
	for (int k=0;k<all.size();k++)
	  if (k!= i && k != j)
	    if (is_left(all[i],all[j],all[k]))
	      sum1+=num[k];
	    else
	      sum2+=num[k];
	ans=max(ans,(sum1+num[i])*(sum2+num[j]));
	ans=max(ans,(sum1)*(sum2+num[i]+num[j]));
	ans=max(ans,(sum1+num[j])*(sum2+num[i]));
	ans=max(ans,(sum1+num[i]+num[j])*(sum2));
      }
    cout<<ans<<endl;
  }
}
